#include <iostream>
// #include <print>
#include <iomanip>
#include <numbers>
#include <cmath>
#include <ranges>
#include <algorithm>
#include <cassert>
#include <numeric>

auto yl1() {
    std::cout << "Sisesta täisarv: ";
    int x = 0;
    std::cin >> x;
    std::cout << (x % 10) << '\n';
    std::cout << (x >>= 1) << '\n';
    std::cout << (x << 2) << '\n';
}

// NB! esimese argumendi tüüp `auto` on meie kasutamises tegelikult
// tüüp `const char*`. Seda vaatame täpsemalt 2. nädalal.
void yl2_print_row(auto tegevus, float weight, int minutes, float met) {
    // NB! Täpitähe kasutamine väljastamisel liigutab joondust
    // Uuri iseseisvalt miks (vihje: tekstikodeering)
    const auto kcal = (weight * (minutes / 60.0) * met);
    std::cout << std::setw(24) << std::left << tegevus
            << std::setw(6) << std::left << minutes
            << std::setw(18) << std::left << kcal
            << '\n';
}

auto yl2() {
    std::cout << "Sisesta kaal: ";
    float weight = 0;
    std::cin >> weight;
    std::cout << "Sisesta aeg minutites: ";
    int minutes = 0;
    std::cin >> minutes;

    std::cout << std::setw(21) << std::left << "Tegevus"
            << std::setw(8) << std::left << "Aeg min"
            << std::setw(14) << std::left << "Kulutatud kcal\n";
    std::cout << "-------------------------------------------\n";

    yl2_print_row("Kõndimine", weight, minutes, 4.0f);
    yl2_print_row("Treppidel käimine", weight, minutes, 5.5f);
    yl2_print_row("Ujumine", weight, minutes, 10.0f);
    yl2_print_row("Korvpall", weight, minutes, 8.0f);

    // std::print (std::format) lahendus
    // NB! Impordi faili alguses päis <print>:
    //     #include <print>
    // Asenda `false` -> `true`
    if (false) {
        std::println("");
        std::println("{:20} {:7} {:13}", "Tegevus", "Aeg min", "Kulutatud kcal");
        std::println("{:-^43}", "");
        std::println("{:20} {:^7} {:^13}", "Kõndimine", minutes, (weight * (minutes / 60.0f) * 4.0f));
        std::println("{:20} {:^7} {:^13}", "Treppidel käimine", minutes, (weight * (minutes / 60.0f) * 5.5f));
        std::println("{:20} {:^7} {:^13}", "Ujumine", minutes, (weight * (minutes / 60.0f) * 10.0f));
        std::println("{:20} {:^7} {:^13}", "Korvpall", minutes, (weight * (minutes / 60.0f) * 8.0f));
    }
}

auto yl3() {
    // NB! Kontrolli, et oled importinud päise <numbers>
    // Miks me ei kasuta siin std::numbers::pi?
    const auto pi = std::numbers::pi_v<float>;

    std::cout << "Sisesta ringi raadius: \n";
    float radius = 0;
    std::cin >> radius;
    const auto area = pi * radius * radius;
    const auto circ = 2 * pi * radius;

    std::cout << "Ringi pindala: " << std::setprecision(4) <<
            area << '\n';
    std::cout << "Ringi ümbermõõt: " << std::setprecision(4) <<
            2 * std::numbers::pi * radius << '\n';
    std::cout << "Raadius kaks korda väiksema pindala korral: " <<
            std::setprecision(4) <<
            std::sqrt(area / 2 / pi) << '\n';

    // std::print (std::format) lahendus
    // Vt yl2 kommentaari
    if (false) {
        std::println("Ringi pindala: {:.2f}", area);
        std::println("Ringi pindala: {:.2f}", circ);
        std::println("Raadius kaks korda väiksema pindala korral: {:.2f}", std::sqrt(area / 2 / pi));
    }
}

// Ülesanne 4.
/*
 * Kirjuta funktsioon, mis tagastab arvu enda, kui see on
 * vähemalt 10 või paaris ning 0 vastasel juhul.
 *
 * Kasuta loodud funktsiooni ja väljasta number ise või nulli korral
 * sõna "null".
 */
auto yl4(int n) {
    // Mõtle, kuidas käitub funktsioon negatiivse arvu korral
    if (n >= 10 || n % 2 == 0) {
        return n;
    }

    return 0;
}

// Ülesanne 5.
/*
 * Kirjuta argumendiga `int n` funktsioon, mis tagastab summa
 * [0-n) kasutades for-tsüklit
 *
 * Kirjuta argumendiga int n funktsioon, mis tagastab summa
 * [0-n) kasutades while-tsüklit
 *
 * Kirjuta argumendiga int n funktsioon, mis tagastab summa
 * [0-n) ilma ühegi tsüklita
 *
 * Näide:
 * kui n = 0, siis tulemus on 0
 * kui n = 1, siis tulemus on 0
 * kui n = 2, siis tulemus on 0 + 1
 * kui n = 3, siis tulemus on 0 + 1 + 2
 */

auto yl5_1(int n) {
    int summa = 0;
    for (int i = 0; i < n; i++) {
        summa += i;
    }
    return summa;
}

auto yl5_2(int n) {
    int summa = 0;
    int i = 0;
    while (i < n) {
        summa += i;
        i++;
    }
    return summa;
}

auto yl5_3(int n) {
    // Vaata: https://en.cppreference.com/w/cpp/ranges
    // Vaata: https://en.cppreference.com/w/cpp/keyword/using
    // Vaata: https://en.wikipedia.org/wiki/Fold_(higher-order_function)

    // Mõtle, mis päiseid vaja, et antud funktsioonid enda programmi saada
    using std::views::iota,
            std::views::take,
            std::ranges::fold_left;

    // NB! See lahendus ei ole triviaalne, see tulnud funktsionaalsetest keeltest.
    // Täpsemalt uurime `std::ranges` päist hiljem.

    auto r = iota(0) | take(n);
    return fold_left(r, 0, std::plus{});
}

// Rekursiivne lähenemine
// Kas saaks teisiti?
auto yl5_3_rec(int n) {
    // Miks (n <= 1)?
    if (n <= 1) {
        return 0;
    }

    // Miks siin (n-1)?
    return (n - 1) + yl5_3_rec(n - 1);
}

int main() {
    // yl1();
    // yl2();
    // yl3();

    // Ülesanne 4.
    // Vaata: https://en.cppreference.com/w/cpp/language/if süntaksi definitsioon 2
    // Mõtle, miks selline "for-init" konstruktsioon võib olla kasulik
    if (const auto x = yl4(2); x != 0) {
        std::cout << x << '\n';
    } else {
        std::cout << "null\n";
    }

    // Ülesanne 5.
    // Funktsiooni `assert` ülesanne on programm krahhida, kui
    // antud tingimus pole tõene. Reeglina selle kasutamine
    // "production" koodis ei ole soovitatud, siin on aga hea
    // kasutada meie loodud funktsioonide valideerimiseks.
    assert(yl5_1(0) == 0);
    assert(yl5_1(1) == 0);
    assert(yl5_1(2) == 1);
    assert(yl5_1(3) == 3);

    assert(yl5_2(0) == 0);
    assert(yl5_2(1) == 0);
    assert(yl5_2(2) == 1);
    assert(yl5_2(3) == 3);

    assert(yl5_3(0) == 0);
    assert(yl5_3(1) == 0);
    assert(yl5_3(2) == 1);
    assert(yl5_3(3) == 3);

    assert(yl5_3_rec(0) == 0);
    assert(yl5_3_rec(1) == 0);
    assert(yl5_3_rec(2) == 1);
    assert(yl5_3_rec(3) == 3);
}
